<?php

namespace Drupal\targets\Controller;

use Drupal\Core\Config\Entity\ConfigEntityListBuilder;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Render\Markup;

/**
 * Provides a listing of Target.
 */
class TargetListBuilder extends ConfigEntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['label'] = $this->t('Target');
    $header['default'] = $this->t('Is Default?');
    $header['prefix'] = $this->t('Prefix');
    $header['preferred_language'] = $this->t('Preferred language');

    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    /** @var \Drupal\targets\TargetInterface $entity */
    $label = sprintf('%s (%s)', $entity->toLink(NULL, 'edit-form')->toString(), $entity->id());
    $row['label'] = Markup::create($label);
    $row['default'] = $entity->isDefault() ? $this->t('Yes') : $this->t('No');
    $row['prefix'] = $entity->getPrefix();
    $language = $entity->getPreferredLanguage();
    $row['preferred_language'] = $language ? $language->getName() : '-';

    return $row + parent::buildRow($entity);
  }

}
